
(function($){
  $.fn.pager = function(options){
    
    var settings = $.extend( {
      'page_max' : 100
      ,'row' : ['']
      ,'th'  : ['']
    }, options); 
 
/*
 * データの読み込み
 */
    var reading = function(div,nowpage){ 
      
      $("#list_div").html('<img src="loader2.gif" />'); 
      
      var page_max = settings.page_max;
      
      var start = 0;
      if( nowpage > 1 ){
        start = (page_max*nowpage) - page_max+1; //2ページ目以降は次の開始位置を計算
      }

      $.ajax({
          type: "POST",
          url: "pager.php",
          data: "page_max="+page_max+"&start="+start,
          async:false,
          success: function(xml){
            var len = $(xml).find("len").text();
            
            page_icon (nowpage,len);
            var len = len.toString().replace( /([0-9]+?)(?=(?:[0-9]{3})+$)/g , '$1,' ); //3桁ごとにカンマ
            $("#ajax_pager").append('<p class="page_message">データ件数は <strong>'+len+'</strong>件です</p>');
            
            var html = '<table>';
            
            html += '<tr>';
              for(var i=0; i<settings.th.length; i++){
                html += '<th>'+settings.th[i]+'</th>';
              }
            html += '</tr>';
            
            
              $(xml).find("item").each(function(){
                html += '<tr>';
                    for(var i=0; i<settings.row.length; i++){
                      html += '<td>'+$(this).find(settings.row[i]).text()+'</td>';
                    }
                html += '</tr>';
              });
              html += '</table>';
              
              $("#list_div").html(html);
          }
      });

    };
    
/*
 * ページアイコンの作成
 */
    var page_icon = function(nowpage,len){ 

      var p = 1; //ページ開始位置

    //7ページ以上ならば、開始ページを1加算
      if(nowpage > 6){
        p = nowpage-5;
      }

      $("#ajax_pager").html('<img src="loader2.gif" />'); 
      
      var page = len/settings.page_max; //全件数をページ表示件数で割る
          page = Math.ceil(page); //小数点切り上げ
      var html = '';
      
        if( nowpage > 1){
          var backpage = nowpage-1; //前のページに戻る数
          html += '<a href="#"  id="page1">&lt;&lt;</a>';
          html += '<a href="#"  id="page'+backpage+'">&lt;</a>';
        }
          
          for(var i=0; i<10; i++){ //最大10ページ分のアイコン
            if(nowpage == p){
              html += '<p class="nowpage">'+p+'</p>'; //現在のページならば
            }else{
              html += '<a href="#" id="page'+p+'">'+p+'</a>';
            }
            p++;
            if(p >= page) break; //ページ数より大きくなったら停止
          }
          
          var nextpage = nowpage+1;
          var endpage  = page-1;
          
          if( endpage != nowpage){
            html += '<a href="#"  id="page'+nextpage+'">&gt;</a>';
            if(page >10) html += '<a href="#" id="page'+endpage+'">&gt;&gt;</a>'; //10ページ以上あるならば
          }
          
        $("#ajax_pager").html(html); //ページアイコンの表示
    };
    
    
/*
 * ページをクリックしたら
 */
    $(document).on('click','#ajax_pager a',function(e){
      var page= $(this).attr("id");
          page = page.match(/page(\d+)/)[1]|0; //page123 からpageを除去*数値にする
          reading(this,page);
      e.preventDefault();
    });
    
    
/*
 * <div id="pager"> 以下に要素の追加
 */
    $(this).prepend('<div id="ajax_pager"></div>');
    $(this).append('<div id="list_div"></div>');

    reading(this,1);
  };
  
})(jQuery)